/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//
//	FileName	motor.c
//	Version		1.00
//	MCU		R8C/2A_2B
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2008/05/30	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	[^]vOłB
//	莞ԂƂɁA[^̑xƉ]ς܂B
//-------------------------------------------------------------------------------------------------
///////////////////////////////////////////////////////////////////////////////////////////////////
/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2008

*/
///////////////////////////////////////////////////////////////////////////////////////////////////
/* CN[ht@C錾 */

#include "R8C_2A_2B.h"

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ֐̃vg^Cv錾 */

void init_IO(void);
void set_CLK(void);
void main(void);
void wait(unsigned long msec);

void init_timer(void);
void wait_m(long msec);
void output_wheel(short duty);


///////////////////////////////////////////////////////////////////////////////////////////////////
/* I/OCvbg */

void init_IO(void)
{
	PRCR = 0x0f;		// veNgWX^
	PD2 = 0x0c;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* NbNZbg */

void set_CLK(void)
{
/* ONbN20MHz */
	CM1 = 0x08;
	CM0 = 0x14; 
	OCD = 0x00; 
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* EFCg */

void wait(unsigned long msec)
{
	unsigned long i;

	for(i=0; i<1000*msec; i++);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ^C}[ */

void init_timer(void)
{
	MSTCR = 0x10;		// ^C}RDgp\
	TRDPMR = 0x01;		// TRDIOB0 PWM[h
	TRDFCR = 0x80;		// ^C}RD@\
	TRDOER1 = 0x0D;		// TRDIOB0̂ݏo͋

	TRDCR0 = 0x24;		// JEg\[Xf32 GRAƂ̃RyA}b`TRDWX^NA
				// 20MHz/32 = 625kHz
	TRDGRA0 = 100;		// PWMg625kHz/100 =6.25kHz
	TRDGRB0 = 5;		// PWMo f[eB5%
	
	asm(" MOV.B #05H,0137H ");	// TRDSTRWX^ ^C}JEgX^[g
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* [^o */

void output_wheel(short duty)
{
	unsigned int mini;
	unsigned int max;
	mini = 1;
	max = 99;
	
	if(duty > 0){				// duty
		P2 = 0x04;			// ԗ֑Oiw
	}
	else if(duty < 0){			// duty
		P2 = 0x08;			// ԗ֌ގw
		duty = -duty;			// ]Ő̒l
	}
	else{					// duty0
		P2 = 0x0c;			// ~w
		TRDGRB0  = mini;
	}
	if(duty > max)     duty = max;		// f[eB̍őlݒ
	if(duty < mini)     duty = mini;	// f[eB̍ŏlݒ
	TRDGRB0 = duty;				// PWMo
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* C֐ */

void main()
{
	init_IO();	// I/OCvbg
	set_CLK();	// NbNZbg
	init_timer();	// ^C}[
	
	while(1)
	{
		output_wheel(50);
		wait(500);
		output_wheel(60);
		wait(500);
		output_wheel(70);
		wait(500);
		output_wheel(0);
		wait(250);
		output_wheel(-50);
		wait(500);
		output_wheel(-60);
		wait(500);
		output_wheel(-70);
		wait(500);
		output_wheel(0);
		wait(250);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
